// ========================================
// Example 2 for the MadPipe macro
// by Gilles Tran (c) 2000
// This example is based on the pipe files used in Eve's morning
// ----------------------------------------
// Beware of the HIGH number of objects in the scene (44500)
// ----------------------------------------
#include "colors.inc"
camera{location  <0.0, 2, -60.0>   direction 1.5*z  right     4/3*x look_at   <0.0, 0.0,  0.0>}
//-----------------------------------------
// Lamp
//-----------------------------------------
light_source{<-1,1,-1>*1000 color White*2}
//-----------------------------------------
// Texture
//-----------------------------------------
#declare colWall=color rgb<0.85,0.95,0.94>*0.6;
#declare colPipe=color rgb<0.95,0.9,0.8>*0.4;
#declare txtPipe1=texture{
        pigment{
                agate
                color_map{
                        [0 color colPipe]
                        [0.3 color colWall]
                        [1 color colWall]
                        }
                } 
        normal{agate 0.1}
        finish{diffuse 0.65 ambient 0}
        }

#declare txtPipe2=texture{
        pigment{
                agate
                color_map{
                        [0 color Copper*2]
                        [0.3 color Copper]
                        [1 color Bronze*2]
                        }
                } 
        normal{agate 0.1}
        finish{metallic brilliance 4 diffuse 0.65 ambient 0}
        }


//-----------------------------------------
// Decorations (must be declared before)
//-----------------------------------------
#declare nDeco=7;
#declare Deco=array[nDeco]
#include "pipedeco.inc"
//#include "pipedeco0.inc" // (test decorations = spheres)

//-----------------------------------------
// Pipes
//-----------------------------------------
#include "madpipe.inc"

#declare box_hole=<0,0,0>;  // no hole = decorations everywhere
#declare dPipe=0; // 3D pipes (dPipe=1 = 2D pipes on the x-y plane)

#declare nPipe=300;
#declare rPipe=0.3;
#declare lPipe=1; 
#declare container=<20,10,2>;  
#declare Pipe_1=object{MadPipe(rPipe,lPipe,nPipe,dPipe,container,box_hole,0,14,true,"wpipe_1.inc") }

#declare nPipe=300;
#declare rPipe=0.2;
#declare lPipe=1; 
#declare container=<10,10,3>;  
#declare Pipe_2=object{MadPipe(rPipe,lPipe,nPipe,dPipe,container,box_hole,0,20,true,"wpipe_2.inc") }

#declare nPipe=100;
#declare rPipe=0.5;
#declare lPipe=1; 
#declare container=<20,5,1>;  
#declare Pipe_3=object{MadPipe(rPipe,lPipe,nPipe,dPipe,container,box_hole,0,30,true,"wpipe_3.inc") }

#declare nPipe=500;
#declare rPipe=0.1;
#declare lPipe=1; 
#declare container=<20,15,2>;  
#declare Pipe_4=object{MadPipe(rPipe,lPipe,nPipe,dPipe,container,box_hole,2,30,true,"wpipe_4.inc") }

//-----------------------------------------
// Pipe placement
// once the pipes are created, just include the files (no need to call the macro)
//-----------------------------------------
union{
        object{#include "WPipe_1.inc" texture{txtPipe2}}
        object{#include "WPipe_2.inc" texture{txtPipe1}}
        object{#include "WPipe_3.inc" texture{txtPipe1}}
        object{#include "WPipe_4.inc" texture{txtPipe1}}
}

plane{z,6 texture{pigment{colWall} finish{diffuse 0.65 ambient 0}}}
